public class BoxBT<T> {

    private T t;          

    public void add(T t) {
        this.t = t;
    }

    public T get() {
        return t;
    }

    public <U extends Number> void inspect(U u) {
        System.out.println("T: " + t.getClass().getName());
        System.out.print("U: " + u.getClass().getName() + ", ");
        System.out.println(u);
    }

    public <U extends Comparable<U>> void compare(U u, U v) {
        System.out.println("T: " + t.getClass().getName());
        System.out.print("U: " + u.getClass().getName() + ", ");
        System.out.println(u);
        System.out.print("V: " + v.getClass().getName() + ", ");
        System.out.println(v);
       	System.out.println(u.compareTo(v));
    }

    public static void main(String[] args) {
        BoxBT<Integer> integerBox = new BoxBT<Integer>();
        integerBox.add(new Integer(10));
        integerBox.inspect(new Float(10.01)); 
        integerBox.inspect(new Integer(5));
        integerBox.compare(new Float(10.01), new Float(5));
        integerBox.compare(new String("abracadabra"), new String("abracadabrZ"));
    }
}
